SystemOrganization addCategory: #SmalltalkHistoryAnalyzer!

Object subclass: #HistoryMSEFilesCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkHistoryAnalyzer'!

!HistoryMSEFilesCreator class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 7/22/2012 04:03'!
example
	self new createMSEFIlesOf:'Roassal' with: 'ConfigurationOfRoassal' saveIn: 'C:\Users\Santiago\Desktop\moose\' versions: #('0.66' '0.67' '0.68' '0.69' '0.70' '0.71' '0.72' '0.73' '0.74' '0.75' '0.76' '0.77' '0.78' '0.79' '0.80' '0.81' '0.82' '0.83' '0.84' '0.85' '0.86'
'0.87'
'0.88'
'0.89'
'0.90'
'0.91'
'0.92'
'0.93'
'0.94'
'0.95'
'0.96'
'0.97'
'0.98'
'0.99'
'0.100'
'0.101'
'0.102'
'0.103'
'0.104'
'0.105'
'0.106'
'0.107'
'0.108'
'0.109'
'0.110'
'0.111'
'0.112'
'0.113'
'0.114'
'0.115'
'0.116'
'0.117'
'0.118'
'0.119'
'0.120'
'0.121'
'0.122'
'0.123'
'0.124'
'0.125'
'0.126'
'0.127'
'0.128'
'0.129'
'0.130'
'0.131'
'0.132'
'0.133'
'0.134'
'0.135'
'0.136'
'0.137'
'0.138'
'0.139'
'0.140'
'0.141'
'0.142'
'0.143'
'0.144'
'0.145'
'0.146'
'0.147'
'0.148'
'0.149'
'0.150'
'0.151'
'0.152'
'0.153'
'0.154'
'0.155'
'0.156'
'0.157'
'0.158'
'0.159'
'0.160'
'0.161'
'0.162'
'0.163'
'1.0'
'1.1'
'1.2'
'1.3'
'1.4'
'1.5'
'1.6'
'1.7'
'1.8'
'1.9'
'1.10'
'1.11'
'1.12'
'1.13'
'1.14'
'1.15'
'1.16'
'1.17'
'1.18'
'1.19'
'1.20'
'1.21'
'1.22'
'1.23'
'1.24'
'1.25'
'1.26'
'1.27'
'1.28'
'1.29'
'1.30'
'1.31'
'1.32'
'1.33'
'1.34'
'1.35'
'1.36'
'1.37'
'1.38'
'1.39'
'1.40'
'1.41'
'1.42'
'1.43'
'1.44'
'1.45'
'1.46'
'1.47'
'1.48'
'1.49'
'1.50'
'1.51'
'1.52'
'1.53'
'1.54'
'1.55'
'1.56'
'1.57'
'1.58'
'1.59'
'1.60'
'1.61'
'1.62'
'1.63'
'1.64'
'1.65'

)  ! !

!HistoryMSEFilesCreator methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 7/22/2012 03:31'!
createImportingContext
	| tmpImportingContext |
	tmpImportingContext := MooseImportingContext new.
	#('LocalVariable' 'Folder' 'ClassExtension' 'Invocation' 'Attribute' 'FormalParameter' 'Inheritance' 'Package' 'Namespace' 'Access' 'ImplicitVariable' 'Argument' 'GlobalVariable' 'Method' 'Literal' 'Comment' 'Class' 'File') do: [ :each | tmpImportingContext perform: (#import , each) asSymbol ].
	tmpImportingContext mergeClassAndMetaclass.
	^ tmpImportingContext! !

!HistoryMSEFilesCreator methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 7/22/2012 11:38'!
createMSEFIlesOf: projectName with: configurationClassName saveIn: aPath versions: aCollectionOfVersions  
	| mooseModel packages task |
Gofer new
		squeaksource: projectName;
		package: configurationClassName;
		load.
		aCollectionOfVersions
		do: [ :version | 
			| project stream|
			project := (Smalltalk at: (configurationClassName asSymbol)) project version: version.
			[ 
			
			project load.	
			packages := self getRealPackagesFromVersion: project.

			mooseModel := MooseModel new.
			mooseModel name: projectName,' ', version.
			(MooseSqueakClassPackageImporterTask new)
				importingContext: self createImportingContext;
				model: mooseModel;
				addFromPackagesNamed: packages;
				candidateClass: CandidateListOperator ;
				runWithProgress.
			
			stream :=MultiByteFileStream newFileNamed:aPath,version,'.mse'.
			mooseModel exportToMSEStream: stream.
			stream close.
				
			 ]
				on: Error
				do: [ :ex | 
					ex halt.
					Transcript show: 'cannot load version ' , version , '  ' , ex printString ] 
				
		
	]! !

!HistoryMSEFilesCreator methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 7/22/2012 11:41'!
getRealPackagesFromVersion: metacelloVersion
	"Return the list of RPackages that belongs to a metacello version
	
	self new getRealPackagesFromVersion: (ConfigurationOfSpirit project version: '1.1')
	"

	| metacelloPackages suffixes |
	
	"We get the metacello packages from the version number"	
	metacelloPackages := (metacelloVersion packages collect: #name).

	suffixes := (metacelloPackages collect: [:p | p copyUpToLast: $- ]) asSet.

	"We now get the real RPackages"
	^ RPackageOrganizer rpackageNames select: [ :p | suffixes anySatisfy: [:t | p beginsWith: t] ]! !
